﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ModbusDemo;
using ModbusDemo.application;
namespace ModbusDemo.application
{
#if DEBUG_TEST  
     public static class AllPond
    {
        #region 东中转池
        private static ModualPool.pcTemperature     cEastTransitPoolTemper              = new ModualPool.pcTemperature("EastTransitPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cEastTransitPoolLevel               = new ModualPool.pcLiquidlevel("EastTransitPoolLevel", 13, "d0");
        private static ModualPool.pcOperation       cEastTransitPoolSouthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolSouthWater          = new ModualPool.pcMachine("EastTransitPoolSouthWater", cEastTransitPoolSouthWaterBase);

        private static ModualPool.pcOperation       cEastTransitPoolNorthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolNorthWater          = new ModualPool.pcMachine("EastTransitPoolNorthWater", cEastTransitPoolNorthWaterBase);

        private static ModualPool.pcOperation       cEastTransitPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolPumb1               = new ModualPool.pcMachine("EastTransitPoolPumb_1", cEastTransitPoolPumb1Base);

        private static ModualPool.pcOperation       cEastTransitPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolPumb2               = new ModualPool.pcMachine("EastTransitPoolPumb_2", cEastTransitPoolPumb2Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = true,
            byResModbusID           = 13,
            strResChannelNumber     = "d0"
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer1            = new ModualPool.pcMachine("EastTransitPoolStirrer_1", cEastTransitPoolStirrer1Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d1",
            strChannelNumber        = new string[] {  "d1" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer2            = new ModualPool.pcMachine("EastTransitPoolStirrer_2", cEastTransitPoolStirrer2Base);


        private static ModualPool.pcOperation       cEastTransitPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer3            = new ModualPool.pcMachine("EastTransitPoolStirrer_3", cEastTransitPoolStirrer3Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer4Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d3",
            strChannelNumber        = new string[] { "d3" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer4            = new ModualPool.pcMachine("EastTransitPoolStirrer_4", cEastTransitPoolStirrer4Base);

        public static List<ModualPool.pcMachine>    EastTransitPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cEastTransitPoolSouthWater, cEastTransitPoolNorthWater, cEastTransitPoolPumb1, cEastTransitPoolPumb2, cEastTransitPoolStirrer1, cEastTransitPoolStirrer2, cEastTransitPoolStirrer3, cEastTransitPoolStirrer4 });
        public static class cEastTransitPool
        {
            public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper      { get => cEastTransitPoolTemper; set => cEastTransitPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel       { get => cEastTransitPoolLevel; set => cEastTransitPoolLevel = value; }
            public static ModualPool.pcMachine cSouthWater      { get => cEastTransitPoolSouthWater; set => cEastTransitPoolSouthWater = value; }
            public static ModualPool.pcMachine cNorthWater      { get => cEastTransitPoolNorthWater; set => cEastTransitPoolNorthWater = value; }
            public static ModualPool.pcMachine cPumb1           { get => cEastTransitPoolPumb1; set => cEastTransitPoolPumb1 = value; }
            public static ModualPool.pcMachine cPumb2           { get => cEastTransitPoolPumb2; set => cEastTransitPoolPumb2 = value; }
            public static ModualPool.pcMachine cStirrer1        { get => cEastTransitPoolStirrer1; set => cEastTransitPoolStirrer1 = value; }
            public static ModualPool.pcMachine cStirrer2        { get => cEastTransitPoolStirrer2; set => cEastTransitPoolStirrer2 = value; }
            public static ModualPool.pcMachine cStirrer3        { get => cEastTransitPoolStirrer3; set => cEastTransitPoolStirrer3 = value; }
            public static ModualPool.pcMachine cStirrer4        { get => cEastTransitPoolStirrer4; set => cEastTransitPoolStirrer4 = value; }

        }
        #endregion 
        #region 西中转池
        private static ModualPool.pcTemperature     cWestTransitPoolTemper              = new ModualPool.pcTemperature("WestTransitPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cWestTransitPoolLevel               = new ModualPool.pcLiquidlevel("WestTransitPoolLevel", 13, "d3");
        private static ModualPool.pcOperation       cWestTransitPoolSouthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 35,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolSouthWater          = new ModualPool.pcMachine("WestTransitPoolSouthWater", cWestTransitPoolSouthWaterBase);

        private static ModualPool.pcOperation       cWestTransitPoolNorthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 35,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolNorthWater          = new ModualPool.pcMachine("WestTransitPoolNorthWater", cWestTransitPoolNorthWaterBase);

        private static ModualPool.pcOperation       cWestTransitPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolPumb1               = new ModualPool.pcMachine("WestTransitPoolPumb_1", cWestTransitPoolPumb1Base);

        private static ModualPool.pcOperation       cWestTransitPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolPumb2               = new ModualPool.pcMachine("WestTransitPoolPumb_2", cWestTransitPoolPumb2Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4","d5" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer1            = new ModualPool.pcMachine("WestTransitPoolStirrer_1", cWestTransitPoolStirrer1Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d1",
            strChannelNumber        = new string[] {  "d1" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer2            = new ModualPool.pcMachine("WestTransitPoolStirrer_2", cWestTransitPoolStirrer2Base);


        private static ModualPool.pcOperation       cWestTransitPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer3            = new ModualPool.pcMachine("WestTransitPoolStirrer_3", cWestTransitPoolStirrer3Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer4Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d3",
            strChannelNumber        = new string[] { "d3" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer4            = new ModualPool.pcMachine("WestTransitPoolStirrer_4", cWestTransitPoolStirrer4Base);

        public static List<ModualPool.pcMachine>    WestTransitPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cWestTransitPoolSouthWater, cWestTransitPoolNorthWater, cWestTransitPoolPumb1, cWestTransitPoolPumb2, cWestTransitPoolStirrer1, cWestTransitPoolStirrer2, cWestTransitPoolStirrer3, cWestTransitPoolStirrer4 });
        public static class cWestTransitPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cWestTransitPoolTemper; set => cWestTransitPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cWestTransitPoolLevel; set => cWestTransitPoolLevel = value; }
            public static ModualPool.pcMachine cSouthWater              { get => cWestTransitPoolSouthWater; set => cWestTransitPoolSouthWater = value; }
            public static ModualPool.pcMachine cNorthWater              { get => cWestTransitPoolNorthWater; set => cWestTransitPoolNorthWater = value; }
            public static ModualPool.pcMachine cPumb1                   { get => cWestTransitPoolPumb1; set => cWestTransitPoolPumb1 = value; }
            public static ModualPool.pcMachine cPumb2                   { get => cWestTransitPoolPumb2; set => cWestTransitPoolPumb2 = value; }
            public static ModualPool.pcMachine cStirrer1                { get => cWestTransitPoolStirrer1; set => cWestTransitPoolStirrer1 = value; }
            public static ModualPool.pcMachine cStirrer2                { get => cWestTransitPoolStirrer2; set => cWestTransitPoolStirrer2 = value; }
            public static ModualPool.pcMachine cStirrer3                { get => cWestTransitPoolStirrer3; set => cWestTransitPoolStirrer3 = value; }
            public static ModualPool.pcMachine cStirrer4                { get => cWestTransitPoolStirrer4; set => cWestTransitPoolStirrer4 = value; }
               
        }
        #endregion 
        #region 沉砂池
        private static ModualPool.pcTemperature     cDesiltingPoolTemper              = new ModualPool.pcTemperature("DesiltingPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cDesiltingPoolLevel               = new ModualPool.pcLiquidlevel("DesiltingPoolLevel", 13, "d4");

        private static ModualPool.pcOperation       cDesiltingPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4" },
            bOpenOperation          = new bool[] { true},
            bCloseOperation         = new bool[] { false},
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb1               = new ModualPool.pcMachine("DesiltingPoolPumb1", cDesiltingPoolPumb1Base);

        private static ModualPool.pcOperation       cDesiltingPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d5",
            strChannelNumber        = new string[] { "d5" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false},
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb2               = new ModualPool.pcMachine("DesiltingPoolPumb2", cDesiltingPoolPumb2Base);

        private static ModualPool.pcOperation       cDesiltingPoolPumb3Base           = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb3               = new ModualPool.pcMachine("DesiltingPoolPumb3", cDesiltingPoolPumb3Base);

        private static ModualPool.pcOperation       cDesiltingPoolPumb4Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb4               = new ModualPool.pcMachine("DesiltingPoolPumb4", cDesiltingPoolPumb4Base);

        private static ModualPool.pcOperation       cDesiltingPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4"},
            bOpenOperation          = new bool[] { true},
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer1            = new ModualPool.pcMachine("DesiltingPoolStirrer1", cDesiltingPoolStirrer1Base);

        private static ModualPool.pcOperation       cDesiltingPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d5",
            strChannelNumber        = new string[] { "d5" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer2            = new ModualPool.pcMachine("DesiltingPoolStirrer2", cDesiltingPoolStirrer2Base);


        private static ModualPool.pcOperation       cDesiltingPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer3            = new ModualPool.pcMachine("DesiltingPoolStirrer3", cDesiltingPoolStirrer3Base);

        private static ModualPool.pcOperation       cDesiltingPoolStirrer4Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d3",
            strChannelNumber        = new string[] { "d3" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer4            = new ModualPool.pcMachine("DesiltingPoolStirrer4", cDesiltingPoolStirrer4Base);

        public static List<ModualPool.pcMachine>    DesiltingPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cDesiltingPoolPumb1, cDesiltingPoolPumb2, cDesiltingPoolPumb3, cDesiltingPoolPumb4, cDesiltingPoolStirrer1, cDesiltingPoolStirrer2, cDesiltingPoolStirrer3, cDesiltingPoolStirrer4 });
        public static class cDesiltingPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cDesiltingPoolTemper; set => cDesiltingPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cDesiltingPoolLevel; set => cDesiltingPoolLevel = value; }
            public static ModualPool.pcMachine cPumb1                   { get => cDesiltingPoolPumb1; set => cDesiltingPoolPumb1 = value; }
            public static ModualPool.pcMachine cPumb2                   { get => cDesiltingPoolPumb2; set => cDesiltingPoolPumb2 = value; }
            public static ModualPool.pcMachine cPumb3                   { get => cDesiltingPoolPumb3; set => cDesiltingPoolPumb3 = value; }
            public static ModualPool.pcMachine cPumb4                   { get => cDesiltingPoolPumb4; set => cDesiltingPoolPumb4 = value; }
            public static ModualPool.pcMachine cStirrer1                { get => cDesiltingPoolStirrer1; set => cDesiltingPoolStirrer1 = value; }
            public static ModualPool.pcMachine cStirrer2                { get => cDesiltingPoolStirrer2; set => cDesiltingPoolStirrer2 = value; }
            public static ModualPool.pcMachine cStirrer3                { get => cDesiltingPoolStirrer3; set => cDesiltingPoolStirrer3 = value; }
            public static ModualPool.pcMachine cStirrer4                { get => cDesiltingPoolStirrer4; set => cDesiltingPoolStirrer4 = value; }
           
            
        }
        #endregion 
        #region 出料池 
        private static ModualPool.pcTemperature     cDischargePoolTemper                = new ModualPool.pcTemperature("DischargePoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cDischargePoolLevel                 = new ModualPool.pcLiquidlevel("DischargePoolLevel", 13, "d0");

        private static ModualPool.pcOperation       cDischargePoolPumb1Base             = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDischargePoolPumb1                 = new ModualPool.pcMachine("DischargePoolPumb1", cDischargePoolPumb1Base);

        private static ModualPool.pcOperation       cDischargePoolStirrer1Base          = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4","d5" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cDischargePoolStirrer1              = new ModualPool.pcMachine("DischargePoolStirrer1", cDischargePoolStirrer1Base);

        public static List<ModualPool.pcMachine>    DischargePoolList                   = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cDischargePoolPumb1, cDischargePoolStirrer1 });
        public static class cDischargePool
        {
            
            public static double  vSetMaxLevel;
            public static double  vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cDischargePoolTemper; set => cDischargePoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cDischargePoolLevel; set => cDischargePoolLevel = value; }
            public static ModualPool.pcMachine     cPumb1               { get => cDischargePoolPumb1; set => cDischargePoolPumb1 = value; }
            public static ModualPool.pcMachine     cStirrer1            { get => cDischargePoolStirrer1; set => cDischargePoolStirrer1 = value; }
 
        }

        #endregion 
        #region 匀浆池
        private static ModualPool.pcTemperature     cSlurryPoolTemper                   = new ModualPool.pcTemperature("SlurryPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cSlurryPoolLevel                    = new ModualPool.pcLiquidlevel("SlurryPoolLevel", 13, "d2");

        private static ModualPool.pcOperation       cSlurryPoolPumb1Base                = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0" },
            bOpenOperation          = new bool[] { true},
            bCloseOperation         = new bool[] { false},
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cSlurryPoolPumb1                    = new ModualPool.pcMachine("SlurryPoolPumb1", cSlurryPoolPumb1Base);

        private static ModualPool.pcOperation       cSlurryPoolStirrer1Base             = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d1",
            strChannelNumber        = new string[] { "d1"},
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false},
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cSlurryPoolStirrer1                 = new ModualPool.pcMachine("SlurryPoolStirrer1 ", cSlurryPoolStirrer1Base);

        public static List<ModualPool.pcMachine>    SlurryPoolList                      = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cSlurryPoolPumb1, cSlurryPoolStirrer1 });
        public static class cSlurryPool
        {
            
            public static double  vSetMaxLevel;
            public static double  vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cSlurryPoolTemper; set => cSlurryPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cSlurryPoolLevel; set => cSlurryPoolLevel = value; }
            public static ModualPool.pcMachine     cPumb1               { get => cSlurryPoolPumb1; set => cSlurryPoolPumb1 = value; }
            public static ModualPool.pcMachine     cStirrer1            { get => cSlurryPoolStirrer1; set => cSlurryPoolStirrer1 = value; }
 
        }
        #endregion 
        #region 八角池
        private static ModualPool.pcTemperature     cOctagonalPoolTemper              = new ModualPool.pcTemperature("OctagonalPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cOctagonalPoolLevel               = new ModualPool.pcLiquidlevel("OctagonalPoolLevel", 13, "d0");

        private static ModualPool.pcOperation       cOctagonalPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 31,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolPumb1               = new ModualPool.pcMachine("OctagonalPoolPumb1 ", cOctagonalPoolPumb1Base);

        private static ModualPool.pcOperation       cOctagonalPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 39,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolPumb2               = new ModualPool.pcMachine("OctagonalPoolPumb2", cOctagonalPoolPumb2Base);

        private static ModualPool.pcOperation       cOctagonalPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d1",
            strChannelNumber        = new string[] {  "d1" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolStirrer1            = new ModualPool.pcMachine("OctagonalPoolStirrer1", cOctagonalPoolStirrer1Base);

        private static ModualPool.pcOperation       cOctagonalPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 90,
            strOperationNumber      = "d1",
            strChannelNumber        = new string[] {  "d1" },
            bOpenOperation          = new bool[] { true },
            bCloseOperation         = new bool[] { false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolStirrer2            = new ModualPool.pcMachine("OctagonalPoolStirrer2", cOctagonalPoolStirrer2Base);

        public static List<ModualPool.pcMachine>    OctagonalPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cOctagonalPoolPumb1, cOctagonalPoolPumb2,  cOctagonalPoolStirrer1, cOctagonalPoolStirrer2 });
        public static class cOctagonalPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cOctagonalPoolTemper; set => cOctagonalPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cOctagonalPoolLevel; set => cOctagonalPoolLevel = value; }
            public static ModualPool.pcMachine cPumb1                   { get => cOctagonalPoolPumb1; set => cOctagonalPoolPumb1 = value; }
            public static ModualPool.pcMachine cPumb2                   { get => cOctagonalPoolPumb2; set => cDesiltingPoolPumb2 = value; }
            public static ModualPool.pcMachine cStirrer1                { get => cOctagonalPoolStirrer1; set => cOctagonalPoolStirrer1 = value; }
            public static ModualPool.pcMachine cStirrer2                { get => cOctagonalPoolStirrer2; set => cOctagonalPoolStirrer2 = value; }             
        }

        #endregion 
        #region 中控柜
        private static ModualPool.pcButtonOperation cStartButton1Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton1         = new ModualPool.pcButton("StartButton1", cStartButton1Base);
        private static ModualPool.pcButtonOperation cStopButton1Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton1          = new ModualPool.pcButton("StopButton1", cStopButton1Base);
        private static ModualPool.pcButtonOperation cPauseButton1Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton1         = new ModualPool.pcButton("PauseButton1", cPauseButton1Base);
        private static ModualPool.pcButtonOperation cHandButton1Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton1          = new ModualPool.pcButton("HandButton1", cHandButton1Base);

        private static ModualPool.pcButtonOperation cStartButton2Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton2         = new ModualPool.pcButton("StartButton2", cStartButton2Base);
        private static ModualPool.pcButtonOperation cStopButton2Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton2          = new ModualPool.pcButton("StopButton2", cStopButton2Base);
        private static ModualPool.pcButtonOperation cPauseButton2Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton2         = new ModualPool.pcButton("PauseButton2", cPauseButton2Base);
        private static ModualPool.pcButtonOperation cHandButton2Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton2          = new ModualPool.pcButton("HandButton2", cHandButton2Base);

        private static ModualPool.pcButtonOperation cStartButton3Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton3         = new ModualPool.pcButton("StartButton3", cStartButton3Base);
        private static ModualPool.pcButtonOperation cStopButton3Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton3          = new ModualPool.pcButton("StopButton3", cStopButton3Base);
        private static ModualPool.pcButtonOperation cPauseButton3Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton3         = new ModualPool.pcButton("PauseButton3", cPauseButton3Base);
        private static ModualPool.pcButtonOperation cHandButton3Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton3          = new ModualPool.pcButton("HandButton3", cHandButton3Base);

        private static ModualPool.pcButtonOperation cStartButton4Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton4         = new ModualPool.pcButton("StartButton4", cStartButton4Base);
        private static ModualPool.pcButtonOperation cStopButton4Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton4          = new ModualPool.pcButton("StopButton4", cStopButton4Base);
        private static ModualPool.pcButtonOperation cPauseButton4Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton4         = new ModualPool.pcButton("PauseButton4", cPauseButton4Base);
        private static ModualPool.pcButtonOperation cHandButton4Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton4          = new ModualPool.pcButton("HandButton4", cHandButton4Base);

        private static ModualPool.pcButtonOperation cStartButton5Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton5         = new ModualPool.pcButton("StartButton5", cStartButton5Base);
        private static ModualPool.pcButtonOperation cStopButton5Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton5          = new ModualPool.pcButton("StopButton5", cStopButton5Base);
        private static ModualPool.pcButtonOperation cPauseButton5Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton5         = new ModualPool.pcButton("PauseButton5", cPauseButton5Base);
        private static ModualPool.pcButtonOperation cHandButton5Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton5          = new ModualPool.pcButton("HandButton5", cHandButton5Base);

        private static ModualPool.pcButtonOperation cStartButton6Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton6         = new ModualPool.pcButton("StartButton6", cStartButton6Base);
        private static ModualPool.pcButtonOperation cStopButton6Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton6          = new ModualPool.pcButton("StopButton6", cStopButton6Base);
        private static ModualPool.pcButtonOperation cPauseButton6Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton6         = new ModualPool.pcButton("PauseButton6", cPauseButton6Base);
        private static ModualPool.pcButtonOperation cHandButton6Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton6          = new ModualPool.pcButton("HandButton6", cHandButton6Base);

        private static ModualPool.pcButtonOperation cStartButton7Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton7         = new ModualPool.pcButton("StartButton7", cStartButton7Base);
        private static ModualPool.pcButtonOperation cStopButton7Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton7          = new ModualPool.pcButton("StopButton7", cStopButton7Base);
        private static ModualPool.pcButtonOperation cPauseButton7Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton7         = new ModualPool.pcButton("PauseButton7", cPauseButton7Base);
        private static ModualPool.pcButtonOperation cHandButton7Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton7          = new ModualPool.pcButton("HandButton7", cHandButton7Base);

        private static ModualPool.pcButtonOperation cStartButton8Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton8         = new ModualPool.pcButton("StartButton8", cStartButton8Base);
        private static ModualPool.pcButtonOperation cStopButton8Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton8          = new ModualPool.pcButton("StopButton8", cStopButton8Base);
        private static ModualPool.pcButtonOperation cPauseButton8Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton8         = new ModualPool.pcButton("PauseButton8", cPauseButton8Base);
        private static ModualPool.pcButtonOperation cHandButton8Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton8          = new ModualPool.pcButton("HandButton8", cHandButton8Base);
        public static class cCentralControlRoom
        {
            public static ModualPool.pcButton cStartButton1                 { get => cStartButton1; set => cStartButton1 = value; }
            public static ModualPool.pcButton cStopButton1                  { get => cStopButton1; set => cStopButton1 = value; } 
            public static ModualPool.pcButton cPauseButton1                 { get => cPauseButton1; set => cPauseButton1 = value; }   
            public static ModualPool.pcButton cHandButton1                  { get => cHandButton1; set => cHandButton1 = value; }     
            public static ModualPool.pcButton cStartButton2                 { get => cStartButton2; set => cStartButton2 = value; }
            public static ModualPool.pcButton cStopButton2                  { get => cStopButton2; set => cStopButton2 = value; } 
            public static ModualPool.pcButton cPauseButton2                 { get => cPauseButton2; set => cPauseButton2 = value; }   
            public static ModualPool.pcButton cHandButton2                  { get => cHandButton2; set => cHandButton2 = value; }      
            public static ModualPool.pcButton cStartButton3                 { get => cStartButton3; set => cStartButton3 = value; }
            public static ModualPool.pcButton cStopButton3                  { get => cStopButton3; set => cStopButton3 = value; } 
            public static ModualPool.pcButton cPauseButton3                 { get => cPauseButton3; set => cPauseButton3 = value; }   
            public static ModualPool.pcButton cHandButton3                  { get => cHandButton3; set => cHandButton3 = value; }  
            public static ModualPool.pcButton cStartButton4                 { get => cStartButton4; set => cStartButton4 = value; }
            public static ModualPool.pcButton cStopButton4                  { get => cStopButton4; set => cStopButton4 = value; } 
            public static ModualPool.pcButton cPauseButton4                 { get => cPauseButton4; set => cPauseButton4 = value; }   
            public static ModualPool.pcButton cHandButton4                  { get => cHandButton4; set => cHandButton4 = value; } 
            public static ModualPool.pcButton cStartButton5                 { get => cStartButton5; set => cStartButton5 = value; }
            public static ModualPool.pcButton cStopButton5                  { get => cStopButton5; set => cStopButton5 = value; } 
            public static ModualPool.pcButton cPauseButton5                 { get => cPauseButton5; set => cPauseButton5 = value; }   
            public static ModualPool.pcButton cHandButton5                  { get => cHandButton5; set => cHandButton5 = value; } 
            public static ModualPool.pcButton cStartButton6                 { get => cStartButton6; set => cStartButton6 = value; }
            public static ModualPool.pcButton cStopButton6                  { get => cStopButton6; set => cStopButton6 = value; } 
            public static ModualPool.pcButton cPauseButton6                 { get => cPauseButton6; set => cPauseButton6 = value; }   
            public static ModualPool.pcButton cHandButton6                  { get => cHandButton6; set => cHandButton6 = value; }   
             public static ModualPool.pcButton cStartButton7                { get => cStartButton7; set => cStartButton7 = value; }
            public static ModualPool.pcButton cStopButton7                  { get => cStopButton7; set => cStopButton7 = value; } 
            public static ModualPool.pcButton cPauseButton7                 { get => cPauseButton7; set => cPauseButton7 = value; }   
            public static ModualPool.pcButton cHandButton7                  { get => cHandButton7; set => cHandButton7 = value; } 
             public static ModualPool.pcButton cStartButton8                { get => cStartButton8; set => cStartButton8 = value; }
            public static ModualPool.pcButton cStopButton8                  { get => cStopButton8; set => cStopButton8 = value; } 
            public static ModualPool.pcButton cPauseButton8                 { get => cPauseButton8; set => cPauseButton8 = value; }   
            public static ModualPool.pcButton cHandButton8                  { get => cHandButton8; set => cHandButton8 = value; }   
        }
        #endregion 
    }
#else 
     public static class AllPond
     {
        #region 东中转池
        private static ModualPool.pcTemperature     cEastTransitPoolTemper              = new ModualPool.pcTemperature("EastTransitPoolTemper", 1, "d0");
        private static ModualPool.pcLiquidlevel     cEastTransitPoolLevel               = new ModualPool.pcLiquidlevel("EastTransitPoolLevel",  3,"d0");
        private static ModualPool.pcOperation       cEastTransitPoolSouthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 4,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolSouthWater          = new ModualPool.pcMachine("EastTransitPoolSouthWater", cEastTransitPoolSouthWaterBase);

        private static ModualPool.pcOperation       cEastTransitPoolNorthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 4,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolNorthWater          = new ModualPool.pcMachine("EastTransitPoolNorthWater", cEastTransitPoolNorthWaterBase);

        private static ModualPool.pcOperation       cEastTransitPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 20,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 86,
            strResChannelNumber     = "d4"
        };
        private static ModualPool.pcMachine         cEastTransitPoolPumb1               = new ModualPool.pcMachine("EastTransitPoolPumb_1", cEastTransitPoolPumb1Base);

        private static ModualPool.pcOperation       cEastTransitPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 20,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = true,
            byResModbusID           = 86,
            strResChannelNumber     = "d0"
        };
        private static ModualPool.pcMachine         cEastTransitPoolPumb2               = new ModualPool.pcMachine("EastTransitPoolPumb_2", cEastTransitPoolPumb2Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 5,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0" ,"d1"},
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 3,
            strResChannelNumber     = "d4"
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer1            = new ModualPool.pcMachine("EastTransitPoolStirrer_1", cEastTransitPoolStirrer1Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 5,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] {  "d2","d3" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 3,
            strResChannelNumber     = "d3"
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer2            = new ModualPool.pcMachine("EastTransitPoolStirrer_2", cEastTransitPoolStirrer2Base);


        private static ModualPool.pcOperation       cEastTransitPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 20,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 86,
            strResChannelNumber     = "d4"
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer3            = new ModualPool.pcMachine("EastTransitPoolStirrer_3", cEastTransitPoolStirrer3Base);

        private static ModualPool.pcOperation       cEastTransitPoolStirrer4Base        = new ModualPool.pcOperation
        {
            byModbusID              = 41,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1","d2","d3" },
            bOpenOperation          = new bool[] { false,true,false,true },
            bCloseOperation         = new bool[] { false,true,true,false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cEastTransitPoolStirrer4            = new ModualPool.pcMachine("EastTransitPoolStirrer_4", cEastTransitPoolStirrer4Base);

        public static List<ModualPool.pcMachine>    EastTransitPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cEastTransitPoolSouthWater, cEastTransitPoolNorthWater, cEastTransitPoolPumb1, cEastTransitPoolPumb2, cEastTransitPoolStirrer1, cEastTransitPoolStirrer2, cEastTransitPoolStirrer3, cEastTransitPoolStirrer4 });

        public static class cEastTransitPool
        {
            public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper      { get => cEastTransitPoolTemper; set => cEastTransitPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel       { get => cEastTransitPoolLevel; set => cEastTransitPoolLevel = value; }
            public static ModualPool.pcMachine cSouthWater      { get => cEastTransitPoolSouthWater; set => cEastTransitPoolSouthWater = value; }
            public static ModualPool.pcMachine cNorthWater      { get => cEastTransitPoolNorthWater; set => cEastTransitPoolNorthWater = value; }
            public static ModualPool.pcMachine c6Pumb1           { get => cEastTransitPoolPumb1; set => cEastTransitPoolPumb1 = value; }
            public static ModualPool.pcMachine c4Pumb2           { get => cEastTransitPoolPumb2; set => cEastTransitPoolPumb2 = value; }
            public static ModualPool.pcMachine c2Stirrer1        { get => cEastTransitPoolStirrer1; set => cEastTransitPoolStirrer1 = value; }
            public static ModualPool.pcMachine c1Stirrer2        { get => cEastTransitPoolStirrer2; set => cEastTransitPoolStirrer2 = value; }
            public static ModualPool.pcMachine c5Stirrer3        { get => cEastTransitPoolStirrer3; set => cEastTransitPoolStirrer3 = value; }
            public static ModualPool.pcMachine c7Stirrer4        { get => cEastTransitPoolStirrer4; set => cEastTransitPoolStirrer4 = value; }

        }
        #endregion
        #region 西中转池
        private static ModualPool.pcTemperature     cWestTransitPoolTemper              = new ModualPool.pcTemperature("WestTransitPoolTemper", 29, "d0");
        private static ModualPool.pcLiquidlevel     cWestTransitPoolLevel               = new ModualPool.pcLiquidlevel("WestTransitPoolLevel", 97, "d0","d1");
        private static ModualPool.pcOperation       cWestTransitPoolSouthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 49,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolSouthWater          = new ModualPool.pcMachine("WestTransitPoolSouthWater", cWestTransitPoolSouthWaterBase);

        private static ModualPool.pcOperation       cWestTransitPoolNorthWaterBase      = new ModualPool.pcOperation
        {
            byModbusID              = 49,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cWestTransitPoolNorthWater          = new ModualPool.pcMachine("WestTransitPoolNorthWater", cWestTransitPoolNorthWaterBase);

        private static ModualPool.pcOperation       cWestTransitPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 37,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 92,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cWestTransitPoolPumb1               = new ModualPool.pcMachine("WestTransitPoolPumb_1", cWestTransitPoolPumb1Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 8,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 97,
            strResChannelNumber     = "d3"
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer1            = new ModualPool.pcMachine("WestTransitPoolStirrer_1", cWestTransitPoolStirrer1Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 8,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2","d3" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 97,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer2            = new ModualPool.pcMachine("WestTransitPoolStirrer_2", cWestTransitPoolStirrer2Base);


        private static ModualPool.pcOperation       cWestTransitPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 37,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 92,
            strResChannelNumber     = "d1"
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer3            = new ModualPool.pcMachine("WestTransitPoolStirrer_3", cWestTransitPoolStirrer3Base);

        private static ModualPool.pcOperation       cWestTransitPoolStirrer4Base        = new ModualPool.pcOperation
        {
            byModbusID              = 37,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4","d5" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 92,
            strResChannelNumber     = "d0"
        };
        private static ModualPool.pcMachine         cWestTransitPoolStirrer4            = new ModualPool.pcMachine("WestTransitPoolStirrer_4", cWestTransitPoolStirrer4Base);

        public static List<ModualPool.pcMachine>    WestTransitPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cWestTransitPoolSouthWater, cWestTransitPoolNorthWater, cWestTransitPoolPumb1, cWestTransitPoolStirrer1, cWestTransitPoolStirrer2, cWestTransitPoolStirrer3, cWestTransitPoolStirrer4 });
        public static class cWestTransitPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cWestTransitPoolTemper; set => cWestTransitPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cWestTransitPoolLevel; set => cWestTransitPoolLevel = value; }
            public static ModualPool.pcMachine cSouthWater              { get => cWestTransitPoolSouthWater; set => cWestTransitPoolSouthWater = value; }
            public static ModualPool.pcMachine cNorthWater              { get => cWestTransitPoolNorthWater; set => cWestTransitPoolNorthWater = value; }  
            public static ModualPool.pcMachine c6Pumb1                   { get => cWestTransitPoolPumb1; set => cWestTransitPoolPumb1 = value; }
            public static ModualPool.pcMachine c2Stirrer1                { get => cWestTransitPoolStirrer1; set => cWestTransitPoolStirrer1 = value; }
            public static ModualPool.pcMachine c1Stirrer2                { get => cWestTransitPoolStirrer2; set => cWestTransitPoolStirrer2 = value; }
            public static ModualPool.pcMachine c5Stirrer3                { get => cWestTransitPoolStirrer3; set => cWestTransitPoolStirrer3 = value; }
            public static ModualPool.pcMachine c4Stirrer4                { get => cWestTransitPoolStirrer4; set => cWestTransitPoolStirrer4 = value; }
               
        }
        #endregion 
        #region 沉砂池
        private static ModualPool.pcTemperature     cDesiltingPoolTemper              = new ModualPool.pcTemperature("DesiltingPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cDesiltingPoolLevel               = new ModualPool.pcLiquidlevel("DesiltingPoolLevel", 12, "d0");

        private static ModualPool.pcOperation       cDesiltingPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 38,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1","d2" },
            bOpenOperation          = new bool[] { true, true,false },
            bCloseOperation         = new bool[] { false, true,true },
            bHadRefControl          = true,
            byResModbusID           = 96,
            strResChannelNumber     = "d1"
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb1               = new ModualPool.pcMachine("DesiltingPoolPumb1", cDesiltingPoolPumb1Base);

        private static ModualPool.pcOperation       cDesiltingPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 38,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4", "d5" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 96,
            strResChannelNumber     = "d0"
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb2               = new ModualPool.pcMachine("DesiltingPoolPumb2", cDesiltingPoolPumb2Base);

        private static ModualPool.pcOperation       cDesiltingPoolPumb3Base           = new ModualPool.pcOperation
        {
            byModbusID              = 51,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 95,
            strResChannelNumber     = "d0"
        };
        private static ModualPool.pcMachine         cDesiltingPoolPumb3               = new ModualPool.pcMachine("DesiltingPoolPumb3", cDesiltingPoolPumb3Base);

        private static ModualPool.pcOperation       cDesiltingPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 24,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 12,
            strResChannelNumber     = "d3"
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer1            = new ModualPool.pcMachine("DesiltingPoolStirrer1", cDesiltingPoolStirrer1Base);

        private static ModualPool.pcOperation       cDesiltingPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 24,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] {  "d2","d3" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false},
            bHadRefControl          = true,
            byResModbusID           = 12,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer2            = new ModualPool.pcMachine("DesiltingPoolStirrer2", cDesiltingPoolStirrer2Base);


        private static ModualPool.pcOperation       cDesiltingPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 24,
            strOperationNumber      = "d4",
            strChannelNumber        = new string[] { "d4","d5" },
            bOpenOperation          = new bool[] { true,true },
            bCloseOperation         = new bool[] { false,false },
            bHadRefControl          = true,
            byResModbusID           = 12,
            strResChannelNumber     = "d1"
        };
        private static ModualPool.pcMachine         cDesiltingPoolStirrer3            = new ModualPool.pcMachine("DesiltingPoolStirrer3", cDesiltingPoolStirrer3Base);

        public static List<ModualPool.pcMachine>    DesiltingPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cDesiltingPoolPumb1, cDesiltingPoolPumb2, cDesiltingPoolPumb3, cDesiltingPoolStirrer1, cDesiltingPoolStirrer2, cDesiltingPoolStirrer3 });
        public static class cDesiltingPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cDesiltingPoolTemper; set => cDesiltingPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cDesiltingPoolLevel; set => cDesiltingPoolLevel = value; }
            public static ModualPool.pcMachine c6Pumb1                   { get => cDesiltingPoolPumb1; set => cDesiltingPoolPumb1 = value; }
            public static ModualPool.pcMachine c5Pumb2                   { get => cDesiltingPoolPumb2; set => cDesiltingPoolPumb2 = value; }
            public static ModualPool.pcMachine c1Pumb3                   { get => cDesiltingPoolPumb3; set => cDesiltingPoolPumb3 = value; } 
            public static ModualPool.pcMachine c4Stirrer1                { get => cDesiltingPoolStirrer1; set => cDesiltingPoolStirrer1 = value; }
            public static ModualPool.pcMachine c3Stirrer2                { get => cDesiltingPoolStirrer2; set => cDesiltingPoolStirrer2 = value; }
            public static ModualPool.pcMachine c2Stirrer3                { get => cDesiltingPoolStirrer3; set => cDesiltingPoolStirrer3 = value; }
           
            
        }
        #endregion
        #region 出料池
        private static ModualPool.pcTemperature     cDischargePoolTemper                = new ModualPool.pcTemperature("DischargePoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cDischargePoolLevel                 = new ModualPool.pcLiquidlevel("DischargePoolLevel", 45, "d0");

        private static ModualPool.pcOperation       cDischargePoolPumb1Base             = new ModualPool.pcOperation
        {
            byModbusID              = 50,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0","d1" },
            bOpenOperation          = new bool[] { true,false },
            bCloseOperation         = new bool[] { false,true },
            bHadRefControl          = true,
            byResModbusID           = 45,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cDischargePoolPumb1                 = new ModualPool.pcMachine("DischargePoolPumb1", cDischargePoolPumb1Base);

        private static ModualPool.pcOperation       cDischargePoolStirrer1Base          = new ModualPool.pcOperation
        {
            byModbusID              = 50,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2", "d3" },
            bOpenOperation          = new bool[] { true, false },
            bCloseOperation         = new bool[] { false, true },
            bHadRefControl          = true,
            byResModbusID           = 45,
            strResChannelNumber     = "d1"
        };
        private static ModualPool.pcMachine         cDischargePoolStirrer1              = new ModualPool.pcMachine("DischargePoolStirrer1", cDischargePoolStirrer1Base);

        public static List<ModualPool.pcMachine>    DischargePoolList                   = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cDischargePoolPumb1, cDischargePoolStirrer1 });
        public static class cDischargePool
        {
            
            public static double  vSetMaxLevel;
            public static double  vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cDischargePoolTemper; set => cDischargePoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cDischargePoolLevel; set => cDischargePoolLevel = value; }
            public static ModualPool.pcMachine     c2Pumb1               { get => cDischargePoolPumb1; set => cDischargePoolPumb1 = value; }
            public static ModualPool.pcMachine     c1Stirrer1            { get => cDischargePoolStirrer1; set => cDischargePoolStirrer1 = value; }
 
        }
        #endregion
        #region 匀浆池
        private static ModualPool.pcTemperature     cSlurryPoolTemper                   = new ModualPool.pcTemperature("SlurryPoolTemper", 17, "d0","d1");
        private static ModualPool.pcLiquidlevel     cSlurryPoolLevel                    = new ModualPool.pcLiquidlevel("SlurryPoolLevel",25, "d0");

        private static ModualPool.pcOperation       cSlurryPoolPumb1Base                = new ModualPool.pcOperation
        {
            byModbusID              = 57,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, false },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 25,
            strResChannelNumber     = "d1"
        };
        private static ModualPool.pcMachine         cSlurryPoolPumb1                    = new ModualPool.pcMachine("SlurryPoolPumb1", cSlurryPoolPumb1Base);

        private static ModualPool.pcOperation       cSlurryPoolStirrer1Base             = new ModualPool.pcOperation
        {
            byModbusID              = 57,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] { "d2","d3" },
            bOpenOperation          = new bool[] { true,false },
            bCloseOperation         = new bool[] { false,true },
            bHadRefControl          = true,
            byResModbusID           = 25,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cSlurryPoolStirrer1                 = new ModualPool.pcMachine("SlurryPoolStirrer1 ", cSlurryPoolStirrer1Base);

        public static List<ModualPool.pcMachine>    SlurryPoolList                      = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cSlurryPoolPumb1, cSlurryPoolStirrer1 });
        public static class cSlurryPool
        {
            
            public static double  vSetMaxLevel;
            public static double  vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cSlurryPoolTemper; set => cSlurryPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cSlurryPoolLevel; set => cSlurryPoolLevel = value; }
            public static ModualPool.pcMachine     c1Pumb1               { get => cSlurryPoolPumb1; set => cSlurryPoolPumb1 = value; }
            public static ModualPool.pcMachine     c2Stirrer1            { get => cSlurryPoolStirrer1; set => cSlurryPoolStirrer1 = value; }
 
        }
        #endregion
        #region 八角池
        private static ModualPool.pcTemperature     cOctagonalPoolTemper              = new ModualPool.pcTemperature("OctagonalPoolTemper", 27, "d0");
        private static ModualPool.pcLiquidlevel     cOctagonalPoolLevel               = new ModualPool.pcLiquidlevel("OctagonalPoolLevel", 21, "d0");

        private static ModualPool.pcOperation       cOctagonalPoolPumb1Base           = new ModualPool.pcOperation
        {
            byModbusID              = 10,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, false },
            bCloseOperation         = new bool[] { false, false },
            bHadRefControl          = true,
            byResModbusID           = 21,
            strResChannelNumber     = "d3"
        };
        private static ModualPool.pcMachine         cOctagonalPoolPumb1               = new ModualPool.pcMachine("OctagonalPoolPumb1 ", cOctagonalPoolPumb1Base);

        private static ModualPool.pcOperation       cOctagonalPoolPumb2Base           = new ModualPool.pcOperation
        {
            byModbusID              = 14,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1","d2" },
            bOpenOperation          = new bool[] { true, true,false },
            bCloseOperation         = new bool[] { false, true,true },
            bHadRefControl          = true,
            byResModbusID           = 21,
            strResChannelNumber     = "d2"
        };
        private static ModualPool.pcMachine         cOctagonalPoolPumb2               = new ModualPool.pcMachine("OctagonalPoolPumb2", cOctagonalPoolPumb2Base);

        private static ModualPool.pcOperation       cOctagonalPoolStirrer1Base        = new ModualPool.pcOperation
        {
            byModbusID              = 10,
            strOperationNumber      = "d2",
            strChannelNumber        = new string[] {  "d2","d3" },
            bOpenOperation          = new bool[] { true,false },
            bCloseOperation         = new bool[] { false,true },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolStirrer1            = new ModualPool.pcMachine("OctagonalPoolStirrer1", cOctagonalPoolStirrer1Base);

        private static ModualPool.pcOperation       cOctagonalPoolStirrer2Base        = new ModualPool.pcOperation
        {
            byModbusID              = 46,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] {  "d0","d1","d2" },
            bOpenOperation          = new bool[] { true,true,false },
            bCloseOperation         = new bool[] { false,true,true },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolStirrer2            = new ModualPool.pcMachine("OctagonalPoolStirrer2", cOctagonalPoolStirrer2Base);

        private static ModualPool.pcOperation       cOctagonalPoolStirrer3Base        = new ModualPool.pcOperation
        {
            byModbusID              = 52,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] {  "d0","d1","d2" },
            bOpenOperation          = new bool[] { true,true,false },
            bCloseOperation         = new bool[] { false,true,true },
            bHadRefControl          = false,
            byResModbusID           = 0xFF,
            strResChannelNumber     = null
        };
        private static ModualPool.pcMachine         cOctagonalPoolStirrer3            = new ModualPool.pcMachine("OctagonalPoolStirrer3", cOctagonalPoolStirrer3Base);

        public static List<ModualPool.pcMachine>    OctagonalPoolList                 = new List<ModualPool.pcMachine>(new ModualPool.pcMachine[] { cOctagonalPoolPumb1, cOctagonalPoolPumb2,  cOctagonalPoolStirrer1, cOctagonalPoolStirrer2,cOctagonalPoolStirrer3 });
        public static class cOctagonalPool
        {
            
             public static double vSetMaxLevel;
            public static double vSetMinLevel;
            public static ModualPool.pcTemperature cTemper              { get => cOctagonalPoolTemper; set => cOctagonalPoolTemper = value; }
            public static ModualPool.pcLiquidlevel cLevel               { get => cOctagonalPoolLevel; set => cOctagonalPoolLevel = value; }
            public static ModualPool.pcMachine c3Pumb1                   { get => cOctagonalPoolPumb1; set => cOctagonalPoolPumb1 = value; }
            public static ModualPool.pcMachine c2Pumb2                   { get => cOctagonalPoolPumb2; set => cDesiltingPoolPumb2 = value; }
            public static ModualPool.pcMachine c1Stirrer1                { get => cOctagonalPoolStirrer1; set => cOctagonalPoolStirrer1 = value; }
            public static ModualPool.pcMachine c4Stirrer2                { get => cOctagonalPoolStirrer2; set => cOctagonalPoolStirrer2 = value; }     
            public static ModualPool.pcMachine c6Stirrer3                { get => cOctagonalPoolStirrer3; set => cOctagonalPoolStirrer3 = value; }  
        }
        #endregion
        #region 中控柜
        private static ModualPool.pcButtonOperation cStartButton1Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton1         = new ModualPool.pcButton("StartButton1", cStartButton1Base);
        private static ModualPool.pcButtonOperation cStopButton1Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton1          = new ModualPool.pcButton("StopButton1", cStopButton1Base);
        private static ModualPool.pcButtonOperation cPauseButton1Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton1         = new ModualPool.pcButton("PauseButton1", cPauseButton1Base);
        private static ModualPool.pcButtonOperation cHandButton1Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton1          = new ModualPool.pcButton("HandButton1", cHandButton1Base);

        private static ModualPool.pcButtonOperation cStartButton2Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton2         = new ModualPool.pcButton("StartButton2", cStartButton2Base);
        private static ModualPool.pcButtonOperation cStopButton2Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton2          = new ModualPool.pcButton("StopButton2", cStopButton2Base);
        private static ModualPool.pcButtonOperation cPauseButton2Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton2         = new ModualPool.pcButton("PauseButton2", cPauseButton2Base);
        private static ModualPool.pcButtonOperation cHandButton2Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton2          = new ModualPool.pcButton("HandButton2", cHandButton2Base);

        private static ModualPool.pcButtonOperation cStartButton3Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton3         = new ModualPool.pcButton("StartButton3", cStartButton3Base);
        private static ModualPool.pcButtonOperation cStopButton3Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton3          = new ModualPool.pcButton("StopButton3", cStopButton3Base);
        private static ModualPool.pcButtonOperation cPauseButton3Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton3         = new ModualPool.pcButton("PauseButton3", cPauseButton3Base);
        private static ModualPool.pcButtonOperation cHandButton3Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton3          = new ModualPool.pcButton("HandButton3", cHandButton3Base);

        private static ModualPool.pcButtonOperation cStartButton4Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton4         = new ModualPool.pcButton("StartButton4", cStartButton4Base);
        private static ModualPool.pcButtonOperation cStopButton4Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton4          = new ModualPool.pcButton("StopButton4", cStopButton4Base);
        private static ModualPool.pcButtonOperation cPauseButton4Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton4         = new ModualPool.pcButton("PauseButton4", cPauseButton4Base);
        private static ModualPool.pcButtonOperation cHandButton4Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton4          = new ModualPool.pcButton("HandButton4", cHandButton4Base);

        private static ModualPool.pcButtonOperation cStartButton5Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton5         = new ModualPool.pcButton("StartButton5", cStartButton5Base);
        private static ModualPool.pcButtonOperation cStopButton5Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton5          = new ModualPool.pcButton("StopButton5", cStopButton5Base);
        private static ModualPool.pcButtonOperation cPauseButton5Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton5         = new ModualPool.pcButton("PauseButton5", cPauseButton5Base);
        private static ModualPool.pcButtonOperation cHandButton5Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton5          = new ModualPool.pcButton("HandButton5", cHandButton5Base);

        private static ModualPool.pcButtonOperation cStartButton6Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton6         = new ModualPool.pcButton("StartButton6", cStartButton6Base);
        private static ModualPool.pcButtonOperation cStopButton6Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton6          = new ModualPool.pcButton("StopButton6", cStopButton6Base);
        private static ModualPool.pcButtonOperation cPauseButton6Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton6         = new ModualPool.pcButton("PauseButton6", cPauseButton6Base);
        private static ModualPool.pcButtonOperation cHandButton6Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton6          = new ModualPool.pcButton("HandButton6", cHandButton6Base);

        private static ModualPool.pcButtonOperation cStartButton7Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton7         = new ModualPool.pcButton("StartButton7", cStartButton7Base);
        private static ModualPool.pcButtonOperation cStopButton7Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton7          = new ModualPool.pcButton("StopButton7", cStopButton7Base);
        private static ModualPool.pcButtonOperation cPauseButton7Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton7         = new ModualPool.pcButton("PauseButton7", cPauseButton7Base);
        private static ModualPool.pcButtonOperation cHandButton7Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton7          = new ModualPool.pcButton("HandButton7", cHandButton7Base);

        private static ModualPool.pcButtonOperation cStartButton8Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStartButton8         = new ModualPool.pcButton("StartButton8", cStartButton8Base);
        private static ModualPool.pcButtonOperation cStopButton8Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cStopButton8          = new ModualPool.pcButton("StopButton8", cStopButton8Base);
        private static ModualPool.pcButtonOperation cPauseButton8Base     = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cPauseButton8         = new ModualPool.pcButton("PauseButton8", cPauseButton8Base);
        private static ModualPool.pcButtonOperation cHandButton8Base      = new ModualPool.pcButtonOperation
        {
            byModbusID              = 16,
            strOperationNumber      = "d0",
            strChannelNumber        = new string[] { "d0", "d1" },
            bOpenOperation          = new bool[] { true, true },
            bCloseOperation         = new bool[] { false, false }
        };
        private static ModualPool.pcButton          cHandButton8          = new ModualPool.pcButton("HandButton8", cHandButton8Base);
        public static class cCentralControlRoom
        {
            public static ModualPool.pcButton cStartButton1                 { get => cStartButton1; set => cStartButton1 = value; }
            public static ModualPool.pcButton cStopButton1                  { get => cStopButton1; set => cStopButton1 = value; } 
            public static ModualPool.pcButton cPauseButton1                 { get => cPauseButton1; set => cPauseButton1 = value; }   
            public static ModualPool.pcButton cHandButton1                  { get => cHandButton1; set => cHandButton1 = value; }     
            public static ModualPool.pcButton cStartButton2                 { get => cStartButton2; set => cStartButton2 = value; }
            public static ModualPool.pcButton cStopButton2                  { get => cStopButton2; set => cStopButton2 = value; } 
            public static ModualPool.pcButton cPauseButton2                 { get => cPauseButton2; set => cPauseButton2 = value; }   
            public static ModualPool.pcButton cHandButton2                  { get => cHandButton2; set => cHandButton2 = value; }      
            public static ModualPool.pcButton cStartButton3                 { get => cStartButton3; set => cStartButton3 = value; }
            public static ModualPool.pcButton cStopButton3                  { get => cStopButton3; set => cStopButton3 = value; } 
            public static ModualPool.pcButton cPauseButton3                 { get => cPauseButton3; set => cPauseButton3 = value; }   
            public static ModualPool.pcButton cHandButton3                  { get => cHandButton3; set => cHandButton3 = value; }  
            public static ModualPool.pcButton cStartButton4                 { get => cStartButton4; set => cStartButton4 = value; }
            public static ModualPool.pcButton cStopButton4                  { get => cStopButton4; set => cStopButton4 = value; } 
            public static ModualPool.pcButton cPauseButton4                 { get => cPauseButton4; set => cPauseButton4 = value; }   
            public static ModualPool.pcButton cHandButton4                  { get => cHandButton4; set => cHandButton4 = value; } 
            public static ModualPool.pcButton cStartButton5                 { get => cStartButton5; set => cStartButton5 = value; }
            public static ModualPool.pcButton cStopButton5                  { get => cStopButton5; set => cStopButton5 = value; } 
            public static ModualPool.pcButton cPauseButton5                 { get => cPauseButton5; set => cPauseButton5 = value; }   
            public static ModualPool.pcButton cHandButton5                  { get => cHandButton5; set => cHandButton5 = value; } 
            public static ModualPool.pcButton cStartButton6                 { get => cStartButton6; set => cStartButton6 = value; }
            public static ModualPool.pcButton cStopButton6                  { get => cStopButton6; set => cStopButton6 = value; } 
            public static ModualPool.pcButton cPauseButton6                 { get => cPauseButton6; set => cPauseButton6 = value; }   
            public static ModualPool.pcButton cHandButton6                  { get => cHandButton6; set => cHandButton6 = value; }   
             public static ModualPool.pcButton cStartButton7                { get => cStartButton7; set => cStartButton7 = value; }
            public static ModualPool.pcButton cStopButton7                  { get => cStopButton7; set => cStopButton7 = value; } 
            public static ModualPool.pcButton cPauseButton7                 { get => cPauseButton7; set => cPauseButton7 = value; }   
            public static ModualPool.pcButton cHandButton7                  { get => cHandButton7; set => cHandButton7 = value; } 
             public static ModualPool.pcButton cStartButton8                { get => cStartButton8; set => cStartButton8 = value; }
            public static ModualPool.pcButton cStopButton8                  { get => cStopButton8; set => cStopButton8 = value; } 
            public static ModualPool.pcButton cPauseButton8                 { get => cPauseButton8; set => cPauseButton8 = value; }   
            public static ModualPool.pcButton cHandButton8                  { get => cHandButton8; set => cHandButton8 = value; }   
        }
        #endregion 
     }
#endif
}
