﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.windows;
using ModbusDemo.Modular;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
using System.IO;

namespace ModbusDemo.application
{
#if DEBUG_TEST
    public class AutoControl
    {
        public class Status
        {
            public bool Beyond_the_limit; //超出极限值
            public bool normal;//正常·工作中
            public bool Minimum_Early_Warning;//低值预警
        }
        public class Control : Status
        {
            public bool Enablation;  //任务使能
            public double maxLevel;
            public double minLevel;
            public double DifferenceValue;
            public double realTimeLevel;
            public bool status;
            public string Name;
            public double StatusTime;
            public int modularx;
            public byte modbusID;
        }

        public static byte[] EmodbusId = { 90, 39 };   //39 CH0/1 CH2/3  //90 CH0/1 CH2/3

        public static byte[] WmodbusId = { 31 };   //31 CH2/3 CH4/5  

        public static byte[] LevelmodbusID = { 13, 13 };   // CH0  CH3



        public static bool[] state_ON = { true, true, true, true };
        public static bool[] state_OFF = { false, false, false, false };

        public static bool[] Read_state;
        public static bool Etimerun = false;
        public static bool Wtimerun = false;

        static System.Diagnostics.Stopwatch ETime = new System.Diagnostics.Stopwatch();
        static System.Diagnostics.Stopwatch WTime = new System.Diagnostics.Stopwatch();
        private static readonly int Runtimeout = 30;

        public static void CriticalValueMonitoring(ref Control usControl, bool Enabl, string Affiliation, out Control control)
        {
            if (usControl.Enablation == true)
            {
                if (usControl.maxLevel != 0.0 && usControl.minLevel != 0.0)
                {
                    InIHelper.WriteConfig("MaxLevel", Affiliation, usControl.maxLevel.ToString());
                    InIHelper.WriteConfig("MinLevel", Affiliation, usControl.minLevel.ToString());
                }
                else
                {
                    usControl.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", Affiliation);
                    usControl.minLevel = InIHelper.ReadConfig<float>("MinLevel", Affiliation);
                }
                //usControl.realTimeLevel = Meanfilter(usControl.realTimeLevel);//实时值

                //usControl.DifferenceValue = usControl.maxLevel - usControl.minLevel;//极值差

                if (usControl.realTimeLevel > usControl.maxLevel)
                {
                    usControl.status = true;
                    usControl.Beyond_the_limit = true;
                    usControl.normal = false;
                    usControl.Minimum_Early_Warning = false;
                }
                else if (usControl.realTimeLevel < usControl.maxLevel && usControl.realTimeLevel > (usControl.minLevel + usControl.minLevel * 0.15))
                {
                    usControl.normal = true;
                    usControl.Beyond_the_limit = false;
                    usControl.Minimum_Early_Warning = false;
                }

                if (usControl.realTimeLevel < (usControl.minLevel - usControl.minLevel * 0.1))
                {
                    usControl.status = false;
                    usControl.Minimum_Early_Warning = true;
                    usControl.Beyond_the_limit = false;
                    usControl.normal = false;
                }

            }
            control = usControl;
        }
        static double[] MeanValue = new double[10];
        public static double Meanfilter(double Value)
        {
            for (int i = 0; i < 10; i++)
            {
                MeanValue[i] = Value;
            }
            Value = MeanValue[0] * 0.1 + MeanValue[5] * 0.3 + MeanValue[9] * 0.6;
            return Value;
        }

        public static void Automatic_control(bool Eenabl, bool Wenabl)
        {
            TimeSpan Wtime = WTime.Elapsed;
            TimeSpan timespan = ETime.Elapsed; //  获取当前实例测量得出的总时间
            for (int i = 0; i < 1; i++)
            {

                if (Eenabl == true)
                {
                    if (Etimerun == false)
                    {
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_ON)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i + 1], 16, state_ON)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        ETime.Start(); //  开始监视运行时间 
                        Etimerun = true;
                    }
                    if (timespan.TotalMinutes > Runtimeout)
                    {
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        if (timespan.TotalMinutes > Runtimeout + Runtimeout * 0.2)
                        {
                            ETime.Reset();
                            ETime.Stop(); //  停止监视
                        }
                    }
                }
                else
                {
                    if (Etimerun == true)
                    {
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_OFF)
                             ==
                             ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                           (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i + 1], 16, state_OFF)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                           )
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],

                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }

                        ETime.Reset();
                        ETime.Stop();
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        Etimerun = false;
                    }
                }

                if (Wenabl == true)
                {
                    if (Wtimerun == false)
                    {
                        if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i], 18, state_ON)
                            ==
                           ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        WTime.Start();//开始监视
                        Wtimerun = true;
                    }
                    if (Wtime.TotalMinutes > Runtimeout)
                    {
                        ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        if (Wtime.TotalMinutes > Runtimeout * 2)
                        {
                            WTime.Reset();
                            WTime.Stop();//停止监视
                        }
                    }
                }
                else
                {
                    if (Wtimerun == true)
                    {
                        if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i], 18, state_OFF)
                        ==
                        ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                        )
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],

                           (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        WTime.Reset();
                        WTime.Stop();//停止监视
                        ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        Wtimerun = false;
                    }
                }

                double Whours = Wtime.TotalHours;
                double Wminures = Wtime.TotalMinutes;
                double Wseconds = Wtime.TotalSeconds;
                double Wmilliseconds = Wtime.TotalMilliseconds;  //  总毫秒数
                double hours = timespan.TotalHours; // 总小时
                double minutes = timespan.TotalMinutes;  // 总分钟
                double seconds = timespan.TotalSeconds;  //  总秒数
                double milliseconds = timespan.TotalMilliseconds;  //  总毫秒数
                //Console.WriteLine(Wtime);
                //Console.WriteLine(timespan);
            }
        }
        static bool Run_flag_bit = false;
        public static void T_AutoControl()
        {
            Control usEcontrol = new Control();
            Control usEcontrolB = new Control();
            Control usWcontrol = new Control();
            Control usWcontrolB = new Control();
            FileInfo file = new FileInfo(InIHelper.FileName);
            Run_flag_bit = true;
            while (true)
            {
                if (ModualControl.cPoolLevelConfig.Count != 0)
                {
                    for (int i = 0; i < ModualControl.cPoolLevelConfig.Count; i++)
                    {
                        for (int j = 0; j < ModualPoll.byX18xNumber; j++)
                        {
                            if (ModualPoll.cx18x.byModbusID[j] == LevelmodbusID[0])
                            {
                                usWcontrol.realTimeLevel =
                                   ModualPoll.cx18x.sX18xDataStruct[j].dNowConvertData[0];
                                usWcontrol.modularx = j;
                                usWcontrol.modbusID = LevelmodbusID[0];
                            }
                            if (ModualPoll.cx18x.byModbusID[j] == LevelmodbusID[1])
                            {
                                usEcontrol.realTimeLevel =
                                    ModualPoll.cx18x.sX18xDataStruct[j].dNowConvertData[3];
                                usEcontrol.modularx = j;
                                usEcontrol.modbusID = LevelmodbusID[1];
                            }
                        }


                        if (ModualControl.cPoolLevelConfig[i].byModbusID == LevelmodbusID[0]
                            && ModualControl.cPoolLevelConfig[i].stChannelNumber == "d0")
                        {
                            usWcontrol.maxLevel = ModualControl.cPoolLevelConfig[i].dUpLevel;
                            usWcontrol.minLevel = ModualControl.cPoolLevelConfig[i].dDownLevel;
                            usWcontrol.Name = "西·中转池";
                            usWcontrol.Enablation = true;
                            InIHelper.WriteConfig("Channel number", "西液位通道", usWcontrol.modularx.ToString());
                            CriticalValueMonitoring(ref usWcontrol,
                              true,
                             "西·中转池",
                             out usWcontrolB
                            );
                        }
                        if (ModualControl.cPoolLevelConfig[i].byModbusID == LevelmodbusID[1]
                            && ModualControl.cPoolLevelConfig[i].stChannelNumber == "d3")
                        {
                            usEcontrol.maxLevel = ModualControl.cPoolLevelConfig[i].dUpLevel;
                            usEcontrol.minLevel = ModualControl.cPoolLevelConfig[i].dDownLevel;
                            usEcontrol.Name = "东·中转池";
                            usEcontrol.Enablation = true;
                            InIHelper.WriteConfig("Channel number", "东液位通道", usEcontrol.modularx.ToString());
                            CriticalValueMonitoring(
                        ref usEcontrol,
                        true,
                        "东·中转池",
                        out usEcontrolB
                        );

                        }
                        ModualControl.cPoolLevelConfig.Remove(ModualControl.cPoolLevelConfig[i]);
                    }
                    Automatic_control(usEcontrolB.status, usWcontrolB.status);
                }
                else if (file.Length != 0)
                {
                    usEcontrol.modularx = InIHelper.ReadConfig<int>("Channel number", "东液位通道");
                    usWcontrol.modularx = InIHelper.ReadConfig<int>("Channel number", "西液位通道");
                    usWcontrol.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", "西·中转池");
                    usWcontrol.minLevel = InIHelper.ReadConfig<float>("MinLevel", "西·中转池");
                    usEcontrol.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", "东·中转池");
                    usEcontrol.minLevel = InIHelper.ReadConfig<float>("MinLevel", "东·中转池");
                    usEcontrol.realTimeLevel =
                        ModualPoll.cx18x.sX18xDataStruct[usEcontrol.modularx].dNowConvertData[0];
                    usWcontrol.realTimeLevel =
                        ModualPoll.cx18x.sX18xDataStruct[usWcontrol.modularx].dNowConvertData[3];
                    usEcontrol.Enablation = true;
                    usWcontrol.Enablation = true;
                    CriticalValueMonitoring(
                     ref usEcontrol,
                     true,
                     "东·中转池",
                     out usEcontrolB
                     );
                    CriticalValueMonitoring(
                      ref usWcontrol,
                      true,
                     "西·中转池",
                     out usWcontrolB
                    );
                    Automatic_control(usEcontrolB.status, usWcontrolB.status);
                }
                else
                {
                    usWcontrol.status = false;
                    usEcontrol.status = false;
                    Automatic_control(usEcontrol.status, usWcontrol.status);
                }
                if (Run_flag_bit == true)
                {
                    if (usEcontrolB.status == false)
                    {
                        if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, EmodbusId[0], 16, 4)
                         ==
                         ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                            ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[0], 16, state_OFF);
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                        }
                        if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, EmodbusId[1], 16, 4)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                            ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[1], 16, state_OFF);
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                        }
                    }
                    if (usWcontrolB.status == false)
                    {
                        if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, WmodbusId[0], 18, 4)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                            ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[0], 18, state_OFF);
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                        }
                    }
                }
                Run_flag_bit = false;
            }
        }
    }

#else
    public class AutoControl
    {
            //Automatic Control Enablation
            //Startcontrol MAX
            //stopcontrol  Min
            //modbuspolling ——water level
            //工作状态
            public class Status
            {
                public bool Beyond_the_limit; //超出极限值
                public bool normal;//正常·工作中
                public bool Minimum_Early_Warning;//低值预警
            }
            public class Control : Status
            {
                public bool Enablation;  //任务使能
                public double maxLevel;
                public double minLevel;
                public double DifferenceValue;
                public double realTimeLevel;
                public bool status;
                public string Name;
                public double StatusTime;
                public int modularx;
                public byte modbusID;
            }
            public static byte[] EmodbusId = { 5, 20 };      //东中转池   东七号柜/ID/41未加入，一路搅拌

            public static byte[] WmodbusId = { 8, 37 };      //西中转池

            public static byte[] LevelmodbusID = { 97, 3 };

            public static bool[] state_ON = { true, true, true, true, true, true };

            public static bool[] state_OFF = { false, false, false, false, false, false };

            public static bool[] Read_state;

            public static bool Etimerun = false;
            public static bool Wtimerun = false;

            static System.Diagnostics.Stopwatch ETime = new System.Diagnostics.Stopwatch();
            static System.Diagnostics.Stopwatch WTime = new System.Diagnostics.Stopwatch();
            private static readonly int Runtimeout = 30;

            public static void CriticalValueMonitoring(ref Control usControl, bool Enabl, string Affiliation, out Control control)
            {
                if (usControl.Enablation == true)
                {
                    if (usControl.maxLevel != 0.0 && usControl.minLevel != 0.0)
                    {
                        InIHelper.WriteConfig("MaxLevel", Affiliation, usControl.maxLevel.ToString());
                        InIHelper.WriteConfig("MinLevel", Affiliation, usControl.minLevel.ToString());
                    }
                    else
                    {
                        usControl.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", Affiliation);
                        usControl.minLevel = InIHelper.ReadConfig<float>("MinLevel", Affiliation);
                    }
                    usControl.realTimeLevel = Meanfilter(usControl.realTimeLevel);//实时值

                    //usControl.DifferenceValue = usControl.maxLevel - usControl.minLevel;//极值差

                    if (usControl.realTimeLevel > usControl.maxLevel)
                    {
                        usControl.status = true;
                        usControl.Beyond_the_limit = true;
                        usControl.normal = false;
                        usControl.Minimum_Early_Warning = false;
                    }
                    else if (usControl.realTimeLevel < usControl.maxLevel && usControl.realTimeLevel > (usControl.minLevel + usControl.minLevel * 0.15))
                    {
                        usControl.normal = true;
                        usControl.Beyond_the_limit = false;
                        usControl.Minimum_Early_Warning = false;
                    }

                    if (usControl.realTimeLevel < (usControl.minLevel - usControl.minLevel * 0.1))
                    {
                        usControl.status = false;
                        usControl.Minimum_Early_Warning = true;
                        usControl.Beyond_the_limit = false;
                        usControl.normal = false;
                    }

                }
                control = usControl;
            }
            static double[] MeanValue = new double[10];
            public static double Meanfilter(double Value)
            {
                for (int i = 0; i < 10; i++)
                {
                    MeanValue[i] = Value;
                }
                Value = MeanValue[0] * 0.1 + MeanValue[5] * 0.3 + MeanValue[9] * 0.6;
                return Value;
            }

            public static void Automatic_control(bool Eenabl, bool Wenabl)
            {
                TimeSpan Wtime = WTime.Elapsed;
                TimeSpan timespan = ETime.Elapsed; //  获取当前实例测量得出的总时间
                for (int i = 0; i < 1; i++)
                {

                    if (Eenabl == true)
                    {
                        if (Etimerun == false)
                        {
                            if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_ON)
                                ==
                                ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i + 1], 16, state_ON)
                                ==
                                ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            ETime.Start(); //  开始监视运行时间 
                            Etimerun = true;
                        }
                        if (timespan.TotalMinutes > Runtimeout)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            if (timespan.TotalMinutes > Runtimeout + Runtimeout * 0.2)
                            {
                                ETime.Reset();
                                ETime.Stop(); //  停止监视
                            }
                        }
                    }
                    else
                    {
                        if (Etimerun == true)
                        {
                            if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_OFF)
                                 ==
                                 ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                               (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i + 1], 16, state_OFF)
                                ==
                                ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                               )
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],

                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }

                            ETime.Reset();
                            ETime.Stop();
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            Etimerun = false;
                        }
                    }

                    if (Wenabl == true)
                    {
                        if (Wtimerun == false)
                        {
                            if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i], 16, state_ON)
                                ==
                               ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i + 1], 16, state_ON)
                                ==
                               ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");

                            }
                            WTime.Start();//开始监视
                            Wtimerun = true;
                        }
                        if (Wtime.TotalMinutes > Runtimeout)
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            if (Wtime.TotalMinutes > Runtimeout * 2)
                            {
                                WTime.Reset();
                                WTime.Stop();//停止监视
                            }
                        }
                    }
                    else
                    {
                        if (Wtimerun == true)
                        {
                            if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i], 16, state_OFF)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                            )
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],

                               (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i + 1], 16, state_OFF)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                            )
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],

                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            }
                            WTime.Reset();
                            WTime.Stop();//停止监视
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                            Wtimerun = false;
                        }
                    }

                    //double Whours = Wtime.TotalHours;
                    //double Wminures = Wtime.TotalMinutes;
                    //double Wseconds = Wtime.TotalSeconds;
                    //double Wmilliseconds = Wtime.TotalMilliseconds;  //总毫秒数
                    //double hours = timespan.TotalHours; // 总小时
                    //double minutes = timespan.TotalMinutes;  // 总分钟
                    //double seconds = timespan.TotalSeconds;  //  总秒数
                    //double milliseconds = timespan.TotalMilliseconds;  //  总毫秒数
                    //Console.WriteLine(Wtime);
                    //Console.WriteLine(timespan);
                }
            }
            static bool Run_flag_bit = false;
            public static void T_AutoControl()
            {
                Control usEcontrol = new Control();
                Control usEcontrolB = new Control();
                Control usWcontrol = new Control();
                Control usWcontrolB = new Control();
                FileInfo file = new FileInfo(InIHelper.FileName);
                Run_flag_bit = true;
                while (true)
                {
                    if (ModualControl.cPoolLevelConfig.Count != 0)
                    {
                        for (int i = 0; i < ModualControl.cPoolLevelConfig.Count; i++)
                        {
                            for (int j = 0; j < ModualPoll.byX18xNumber; j++)
                            {
                                if (ModualPoll.cx18x.byModbusID[j] == LevelmodbusID[0])
                                {
                                    usWcontrol.realTimeLevel =
                                       ModualPoll.cx18x.sX18xDataStruct[j].dNowConvertData[1];
                                    usWcontrol.modularx = j;
                                    usWcontrol.modbusID = LevelmodbusID[0];
                                }
                                if (ModualPoll.cx18x.byModbusID[j] == LevelmodbusID[1])
                                {
                                    usEcontrol.realTimeLevel =
                                        ModualPoll.cx18x.sX18xDataStruct[j].dNowConvertData[1];
                                    usEcontrol.modularx = j;
                                    usEcontrol.modbusID = LevelmodbusID[1];
                                }
                            }


                            if (ModualControl.cPoolLevelConfig[i].byModbusID == LevelmodbusID[0]
                                && ModualControl.cPoolLevelConfig[i].stChannelNumber == "d0")
                            {
                                usWcontrol.maxLevel = ModualControl.cPoolLevelConfig[i].dUpLevel;
                                usWcontrol.minLevel = ModualControl.cPoolLevelConfig[i].dDownLevel;
                                usWcontrol.Name = "西·中转池";
                                usWcontrol.Enablation = true;
                                InIHelper.WriteConfig("Channel number", "西液位通道", usWcontrol.modularx.ToString());
                                CriticalValueMonitoring(ref usWcontrol,
                                  true,
                                 "西·中转池",
                                 out usWcontrolB
                                );
                            }
                            if (ModualControl.cPoolLevelConfig[i].byModbusID == LevelmodbusID[1]
                                && ModualControl.cPoolLevelConfig[i].stChannelNumber == "d0")
                            {
                                usEcontrol.maxLevel = ModualControl.cPoolLevelConfig[i].dUpLevel;
                                usEcontrol.minLevel = ModualControl.cPoolLevelConfig[i].dDownLevel;
                                usEcontrol.Name = "东·中转池";
                                usEcontrol.Enablation = true;
                                InIHelper.WriteConfig("Channel number", "东液位通道", usEcontrol.modularx.ToString());
                                CriticalValueMonitoring(
                            ref usEcontrol,
                            true,
                            "东·中转池",
                            out usEcontrolB
                            );

                            }
                            ModualControl.cPoolLevelConfig.Remove(ModualControl.cPoolLevelConfig[i]);
                        }
                        Automatic_control(usEcontrolB.status, usWcontrolB.status);
                    }
                    else if (file.Length != 0)
                    {
                        usEcontrol.modularx = InIHelper.ReadConfig<int>("Channel number", "东液位通道");
                        usWcontrol.modularx = InIHelper.ReadConfig<int>("Channel number", "西液位通道");
                        usWcontrol.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", "西·中转池");
                        usWcontrol.minLevel = InIHelper.ReadConfig<float>("MinLevel", "西·中转池");
                        usEcontrol.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", "东·中转池");
                        usEcontrol.minLevel = InIHelper.ReadConfig<float>("MinLevel", "东·中转池");
                        usEcontrol.realTimeLevel =
                            ModualPoll.cx18x.sX18xDataStruct[usEcontrol.modularx].dNowConvertData[0];
                        usWcontrol.realTimeLevel =
                            ModualPoll.cx18x.sX18xDataStruct[usWcontrol.modularx].dNowConvertData[0];
                        usEcontrol.Enablation = true;
                        usWcontrol.Enablation = true;
                        CriticalValueMonitoring(
                         ref usEcontrol,
                         true,
                         "东·中转池",
                         out usEcontrolB
                         );
                        CriticalValueMonitoring(
                          ref usWcontrol,
                          true,
                         "西·中转池",
                         out usWcontrolB
                        );
                        Automatic_control(usEcontrolB.status, usWcontrolB.status);
                    }
                    else
                    {
                        usWcontrol.status = false;
                        usEcontrol.status = false;
                        Automatic_control(usEcontrol.status, usWcontrol.status);
                    }
                    if (Run_flag_bit == true)
                    {
                        if (usEcontrolB.status == false)
                        {
                            if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, EmodbusId[0], 16, 4)
                             ==
                             ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                                ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[0], 16, state_OFF);
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                            }
                            if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, EmodbusId[1], 16, 6)
                                ==
                                ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                                ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[1], 16, state_OFF);
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                            }
                        }
                        if (usWcontrolB.status == false)
                        {
                            if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, WmodbusId[0], 16, 4)
                                ==
                                ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                            {
                                ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                                ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[0], 16, state_OFF);
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(WmodbusId[1],
                                (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                                "d0", "d1", "d2", "d3", "d4", "d5");
                            }
                        if (ModbusComm.Modbus_ReadCoilsTask(out Read_state, WmodbusId[1], 16, 6)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[0],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                            ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[0], 16, state_OFF);
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5");
                        }
                    }
                    }
                    Run_flag_bit = false;
                }
            }

    }
#endif
}
